//+------------------------------------------------------------------+
//|                                                     DateTime.mqh |
//|                                      Copyright  2007, BabyBear. |
//|                               http://bearden.narod.ru/index.html |
//+------------------------------------------------------------------+
#property copyright "Copyright  2007, BabyBear."
#property link      "http://bearden.narod.ru/index.html"
//      2007 
//       
//     WEEK_LENGTH,   
#define ONE_FRIDAY_END 1168038037
//  
// 7*24*60*60
#define WEEK_LENGTH 604800
//    .        
//   22:59,      
// (24 + 23)*60*60; 
#define WEEK_END_LENGTH 169200
//+------------------------------------------------------------------+
//|     22:00                          |
//+------------------------------------------------------------------+
datetime LastMondayStart(datetime dt)
  {
   datetime MondayStart = ONE_FRIDAY_END + WEEK_END_LENGTH;
   while (MondayStart < dt)
       MondayStart += WEEK_LENGTH;
   return(MondayStart - WEEK_LENGTH);   
  }
//+------------------------------------------------------------------+
//|    23:00                                   |
//+------------------------------------------------------------------+
datetime NextFridayEnd( datetime dt)
  {
   datetime FridayEnd = ONE_FRIDAY_END;
   while (FridayEnd < dt)
       FridayEnd += WEEK_LENGTH;
   return(FridayEnd);   
  }
//+------------------------------------------------------------------+
//|                         |
//+------------------------------------------------------------------+
int SundayMidnightCount( datetime start, datetime end)
  {
   datetime s = LastMondayStart(start);
   datetime e = LastMondayStart(end);
   int result = 0;
   while(s < e)
     {
       s += WEEK_LENGTH;
       result++;
     }
   return(result);
  }
//+------------------------------------------------------------------+
//|                                    |
//+------------------------------------------------------------------+
int HoursCandleCount( datetime start, datetime end)
  {
   datetime s = start + SundayMidnightCount(start, end)*WEEK_END_LENGTH;
   int result = 0;
   while(s < end)
     {
       s += 3600;  // one hour
       result++;
     }
   return(result);
  }
//+------------------------------------------------------------------+
//|                                       |
//+------------------------------------------------------------------+
datetime AddTradingSeconds(datetime start, int seconds)
  {
   int trading_week_length = 5*24*60*60;
   int s = seconds;
   datetime result = start;
//----   
   while(s > trading_week_length)
     {
       s -= trading_week_length;
       result += WEEK_LENGTH;
     }
//----
   if(NextFridayEnd(result) !=  NextFridayEnd(result + s))
       result += 2*24*60*60; 
   return(result + s);
  }
//+------------------------------------------------------------------+

